4c583b033d7e60ce2c4d4a92f48fcf2af68b8003
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Keep the original TERM for say_color
  19ORIGINAL_TERM=$TERM
  20
  21# Test the binaries we have just built.  The tests are kept in
  22# t/ subdirectory and are run in 'trash directory' subdirectory.
  23if test -z "$TEST_DIRECTORY"
  24then
  25        # We allow tests to override this, in case they want to run tests
  26        # outside of t/, e.g. for running tests on the test library
  27        # itself.
  28        TEST_DIRECTORY=$(pwd)
  29fi
  30if test -z "$TEST_OUTPUT_DIRECTORY"
  31then
  32        # Similarly, override this to store the test-results subdir
  33        # elsewhere
  34        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  35fi
  36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  37
  38################################################################
  39# It appears that people try to run tests without building...
  40"$GIT_BUILD_DIR/git" >/dev/null
  41if test $? != 1
  42then
  43        echo >&2 'error: you do not seem to have built git yet.'
  44        exit 1
  45fi
  46
  47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  48export PERL_PATH SHELL_PATH
  49
  50# if --tee was passed, write the output not only to the terminal, but
  51# additionally to the file test-results/$BASENAME.out, too.
  52case "$GIT_TEST_TEE_STARTED, $* " in
  53done,*)
  54        # do not redirect again
  55        ;;
  56*' --tee '*|*' --va'*)
  57        mkdir -p test-results
  58        BASE=test-results/$(basename "$0" .sh)
  59        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  60         echo $? > $BASE.exit) | tee $BASE.out
  61        test "$(cat $BASE.exit)" = 0
  62        exit
  63        ;;
  64esac
  65
  66# For repeatability, reset the environment to known value.
  67LANG=C
  68LC_ALL=C
  69PAGER=cat
  70TZ=UTC
  71TERM=dumb
  72export LANG LC_ALL PAGER TERM TZ
  73EDITOR=:
  74# A call to "unset" with no arguments causes at least Solaris 10
  75# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  76# deriving from the command substitution clustered with the other
  77# ones.
  78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  79        my @env = keys %ENV;
  80        my $ok = join("|", qw(
  81                TRACE
  82                DEBUG
  83                USE_LOOKUP
  84                TEST
  85                .*_TEST
  86                PROVE
  87                VALGRIND
  88                UNZIP
  89                PERF_
  90        ));
  91        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  92        print join("\n", @vars);
  93')
  94unset XDG_CONFIG_HOME
  95GIT_AUTHOR_EMAIL=author@example.com
  96GIT_AUTHOR_NAME='A U Thor'
  97GIT_COMMITTER_EMAIL=committer@example.com
  98GIT_COMMITTER_NAME='C O Mitter'
  99GIT_MERGE_VERBOSITY=5
 100GIT_MERGE_AUTOEDIT=no
 101export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 102export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 103export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 104export EDITOR
 105
 106# Add libc MALLOC and MALLOC_PERTURB test
 107# only if we are not executing the test with valgrind
 108if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 109   test -n "$TEST_NO_MALLOC_CHECK"
 110then
 111        setup_malloc_check () {
 112                : nothing
 113        }
 114        teardown_malloc_check () {
 115                : nothing
 116        }
 117else
 118        setup_malloc_check () {
 119                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 120                export MALLOC_CHECK_ MALLOC_PERTURB_
 121        }
 122        teardown_malloc_check () {
 123                unset MALLOC_CHECK_ MALLOC_PERTURB_
 124        }
 125fi
 126
 127# Protect ourselves from common misconfiguration to export
 128# CDPATH into the environment
 129unset CDPATH
 130
 131unset GREP_OPTIONS
 132unset UNZIP
 133
 134case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1351|2|true)
 136        echo "* warning: Some tests will not work if GIT_TRACE" \
 137                "is set as to trace on STDERR ! *"
 138        echo "* warning: Please set GIT_TRACE to something" \
 139                "other than 1, 2 or true ! *"
 140        ;;
 141esac
 142
 143# Convenience
 144#
 145# A regexp to match 5 and 40 hexdigits
 146_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 147_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 148
 149# Zero SHA-1
 150_z40=0000000000000000000000000000000000000000
 151
 152# Line feed
 153LF='
 154'
 155
 156export _x05 _x40 _z40 LF
 157
 158# Each test should start with something like this, after copyright notices:
 159#
 160# test_description='Description of this test...
 161# This test checks if command xyzzy does the right thing...
 162# '
 163# . ./test-lib.sh
 164[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 165                TERM=$ORIGINAL_TERM &&
 166                export TERM &&
 167                [ -t 1 ] &&
 168                tput bold >/dev/null 2>&1 &&
 169                tput setaf 1 >/dev/null 2>&1 &&
 170                tput sgr0 >/dev/null 2>&1
 171        ) &&
 172        color=t
 173
 174while test "$#" -ne 0
 175do
 176        case "$1" in
 177        -d|--d|--de|--deb|--debu|--debug)
 178                debug=t; shift ;;
 179        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 180                immediate=t; shift ;;
 181        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 182                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 183        -h|--h|--he|--hel|--help)
 184                help=t; shift ;;
 185        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 186                verbose=t; shift ;;
 187        -q|--q|--qu|--qui|--quie|--quiet)
 188                # Ignore --quiet under a TAP::Harness. Saying how many tests
 189                # passed without the ok/not ok details is always an error.
 190                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 191        --with-dashes)
 192                with_dashes=t; shift ;;
 193        --no-color)
 194                color=; shift ;;
 195        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 196                valgrind=memcheck
 197                shift ;;
 198        --valgrind=*)
 199                valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
 200                shift ;;
 201        --tee)
 202                shift ;; # was handled already
 203        --root=*)
 204                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 205                shift ;;
 206        *)
 207                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 208        esac
 209done
 210
 211test -n "$valgrind" && verbose=t
 212
 213if test -n "$color"
 214then
 215        say_color () {
 216                (
 217                TERM=$ORIGINAL_TERM
 218                export TERM
 219                case "$1" in
 220                error)
 221                        tput bold; tput setaf 1;; # bold red
 222                skip)
 223                        tput setaf 4;; # blue
 224                warn)
 225                        tput setaf 3;; # brown/yellow
 226                pass)
 227                        tput setaf 2;; # green
 228                info)
 229                        tput setaf 6;; # cyan
 230                *)
 231                        test -n "$quiet" && return;;
 232                esac
 233                shift
 234                printf "%s" "$*"
 235                tput sgr0
 236                echo
 237                )
 238        }
 239else
 240        say_color() {
 241                test -z "$1" && test -n "$quiet" && return
 242                shift
 243                printf "%s\n" "$*"
 244        }
 245fi
 246
 247error () {
 248        say_color error "error: $*"
 249        GIT_EXIT_OK=t
 250        exit 1
 251}
 252
 253say () {
 254        say_color info "$*"
 255}
 256
 257test "${test_description}" != "" ||
 258error "Test script did not set test_description."
 259
 260if test "$help" = "t"
 261then
 262        echo "$test_description"
 263        exit 0
 264fi
 265
 266exec 5>&1
 267exec 6<&0
 268if test "$verbose" = "t"
 269then
 270        exec 4>&2 3>&1
 271else
 272        exec 4>/dev/null 3>/dev/null
 273fi
 274
 275test_failure=0
 276test_count=0
 277test_fixed=0
 278test_broken=0
 279test_success=0
 280
 281test_external_has_tap=0
 282
 283die () {
 284        code=$?
 285        if test -n "$GIT_EXIT_OK"
 286        then
 287                exit $code
 288        else
 289                echo >&5 "FATAL: Unexpected exit with code $code"
 290                exit 1
 291        fi
 292}
 293
 294GIT_EXIT_OK=
 295trap 'die' EXIT
 296
 297# The user-facing functions are loaded from a separate file so that
 298# test_perf subshells can have them too
 299. "$TEST_DIRECTORY/test-lib-functions.sh"
 300
 301# You are not expected to call test_ok_ and test_failure_ directly, use
 302# the text_expect_* functions instead.
 303
 304test_ok_ () {
 305        test_success=$(($test_success + 1))
 306        say_color "" "ok $test_count - $@"
 307}
 308
 309test_failure_ () {
 310        test_failure=$(($test_failure + 1))
 311        say_color error "not ok $test_count - $1"
 312        shift
 313        echo "$@" | sed -e 's/^/#       /'
 314        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 315}
 316
 317test_known_broken_ok_ () {
 318        test_fixed=$(($test_fixed+1))
 319        say_color error "ok $test_count - $@ # TODO known breakage vanished"
 320}
 321
 322test_known_broken_failure_ () {
 323        test_broken=$(($test_broken+1))
 324        say_color warn "not ok $test_count - $@ # TODO known breakage"
 325}
 326
 327test_debug () {
 328        test "$debug" = "" || eval "$1"
 329}
 330
 331match_pattern_list () {
 332        arg="$1"
 333        shift
 334        test -z "$*" && return 1
 335        for pattern_
 336        do
 337                case "$arg" in
 338                $pattern_)
 339                        return 0
 340                esac
 341        done
 342        return 1
 343}
 344
 345test_eval_ () {
 346        # This is a separate function because some tests use
 347        # "return" to end a test_expect_success block early.
 348        eval </dev/null >&3 2>&4 "$*"
 349}
 350
 351test_run_ () {
 352        test_cleanup=:
 353        expecting_failure=$2
 354        setup_malloc_check
 355        test_eval_ "$1"
 356        eval_ret=$?
 357        teardown_malloc_check
 358
 359        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 360        then
 361                setup_malloc_check
 362                test_eval_ "$test_cleanup"
 363                teardown_malloc_check
 364        fi
 365        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 366        then
 367                echo ""
 368        fi
 369        return "$eval_ret"
 370}
 371
 372test_skip () {
 373        test_count=$(($test_count+1))
 374        to_skip=
 375        if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
 376        then
 377                to_skip=t
 378        fi
 379        if test -z "$to_skip" && test -n "$test_prereq" &&
 380           ! test_have_prereq "$test_prereq"
 381        then
 382                to_skip=t
 383        fi
 384        case "$to_skip" in
 385        t)
 386                of_prereq=
 387                if test "$missing_prereq" != "$test_prereq"
 388                then
 389                        of_prereq=" of $test_prereq"
 390                fi
 391
 392                say_color skip >&3 "skipping test: $@"
 393                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 394                : true
 395                ;;
 396        *)
 397                false
 398                ;;
 399        esac
 400}
 401
 402# stub; perf-lib overrides it
 403test_at_end_hook_ () {
 404        :
 405}
 406
 407test_done () {
 408        GIT_EXIT_OK=t
 409
 410        if test -z "$HARNESS_ACTIVE"
 411        then
 412                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 413                mkdir -p "$test_results_dir"
 414                base=${0##*/}
 415                test_results_path="$test_results_dir/${base%.sh}-$$.counts"
 416
 417                cat >>"$test_results_path" <<-EOF
 418                total $test_count
 419                success $test_success
 420                fixed $test_fixed
 421                broken $test_broken
 422                failed $test_failure
 423
 424                EOF
 425        fi
 426
 427        if test "$test_fixed" != 0
 428        then
 429                say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
 430        fi
 431        if test "$test_broken" != 0
 432        then
 433                say_color warn "# still have $test_broken known breakage(s)"
 434        fi
 435        if test "$test_broken" != 0 || test "$test_fixed" != 0
 436        then
 437                test_remaining=$(( $test_count - $test_broken - $test_fixed ))
 438                msg="remaining $test_remaining test(s)"
 439        else
 440                test_remaining=$test_count
 441                msg="$test_count test(s)"
 442        fi
 443        case "$test_failure" in
 444        0)
 445                # Maybe print SKIP message
 446                if test -n "$skip_all" && test $test_count -gt 0
 447                then
 448                        error "Can't use skip_all after running some tests"
 449                fi
 450                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 451
 452                if test $test_external_has_tap -eq 0
 453                then
 454                        if test $test_remaining -gt 0
 455                        then
 456                                say_color pass "# passed all $msg"
 457                        fi
 458                        say "1..$test_count$skip_all"
 459                fi
 460
 461                test -d "$remove_trash" &&
 462                cd "$(dirname "$remove_trash")" &&
 463                rm -rf "$(basename "$remove_trash")"
 464
 465                test_at_end_hook_
 466
 467                exit 0 ;;
 468
 469        *)
 470                if test $test_external_has_tap -eq 0
 471                then
 472                        say_color error "# failed $test_failure among $msg"
 473                        say "1..$test_count"
 474                fi
 475
 476                exit 1 ;;
 477
 478        esac
 479}
 480
 481if test -n "$valgrind"
 482then
 483        make_symlink () {
 484                test -h "$2" &&
 485                test "$1" = "$(readlink "$2")" || {
 486                        # be super paranoid
 487                        if mkdir "$2".lock
 488                        then
 489                                rm -f "$2" &&
 490                                ln -s "$1" "$2" &&
 491                                rm -r "$2".lock
 492                        else
 493                                while test -d "$2".lock
 494                                do
 495                                        say "Waiting for lock on $2."
 496                                        sleep 1
 497                                done
 498                        fi
 499                }
 500        }
 501
 502        make_valgrind_symlink () {
 503                # handle only executables, unless they are shell libraries that
 504                # need to be in the exec-path.  We will just use "#!" as a
 505                # guess for a shell-script, since we have no idea what the user
 506                # may have configured as the shell path.
 507                test -x "$1" ||
 508                test "#!" = "$(head -c 2 <"$1")" ||
 509                return;
 510
 511                base=$(basename "$1")
 512                symlink_target=$GIT_BUILD_DIR/$base
 513                # do not override scripts
 514                if test -x "$symlink_target" &&
 515                    test ! -d "$symlink_target" &&
 516                    test "#!" != "$(head -c 2 < "$symlink_target")"
 517                then
 518                        symlink_target=../valgrind.sh
 519                fi
 520                case "$base" in
 521                *.sh|*.perl)
 522                        symlink_target=../unprocessed-script
 523                esac
 524                # create the link, or replace it if it is out of date
 525                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 526        }
 527
 528        # override all git executables in TEST_DIRECTORY/..
 529        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 530        mkdir -p "$GIT_VALGRIND"/bin
 531        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 532        do
 533                make_valgrind_symlink $file
 534        done
 535        # special-case the mergetools loadables
 536        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 537        OLDIFS=$IFS
 538        IFS=:
 539        for path in $PATH
 540        do
 541                ls "$path"/git-* 2> /dev/null |
 542                while read file
 543                do
 544                        make_valgrind_symlink "$file"
 545                done
 546        done
 547        IFS=$OLDIFS
 548        PATH=$GIT_VALGRIND/bin:$PATH
 549        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 550        export GIT_VALGRIND
 551        GIT_VALGRIND_MODE="$valgrind"
 552        export GIT_VALGRIND_MODE
 553elif test -n "$GIT_TEST_INSTALLED"
 554then
 555        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 556        error "Cannot run git from $GIT_TEST_INSTALLED."
 557        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 558        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 559else # normal case, use ../bin-wrappers only unless $with_dashes:
 560        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 561        if ! test -x "$git_bin_dir/git"
 562        then
 563                if test -z "$with_dashes"
 564                then
 565                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 566                fi
 567                with_dashes=t
 568        fi
 569        PATH="$git_bin_dir:$PATH"
 570        GIT_EXEC_PATH=$GIT_BUILD_DIR
 571        if test -n "$with_dashes"
 572        then
 573                PATH="$GIT_BUILD_DIR:$PATH"
 574        fi
 575fi
 576GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 577unset GIT_CONFIG
 578GIT_CONFIG_NOSYSTEM=1
 579GIT_ATTR_NOSYSTEM=1
 580export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 581
 582if test -z "$GIT_TEST_CMP"
 583then
 584        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 585        then
 586                GIT_TEST_CMP="$DIFF -c"
 587        else
 588                GIT_TEST_CMP="$DIFF -u"
 589        fi
 590fi
 591
 592GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 593export GITPERLLIB
 594test -d "$GIT_BUILD_DIR"/templates/blt || {
 595        error "You haven't built things yet, have you?"
 596}
 597
 598if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 599then
 600        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 601        export GITPYTHONLIB
 602        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 603                error "You haven't built git_remote_helpers yet, have you?"
 604        }
 605fi
 606
 607if ! test -x "$GIT_BUILD_DIR"/test-chmtime
 608then
 609        echo >&2 'You need to build test-chmtime:'
 610        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 611        exit 1
 612fi
 613
 614# Test repository
 615TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
 616test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
 617case "$TRASH_DIRECTORY" in
 618/*) ;; # absolute path is good
 619 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
 620esac
 621test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 622rm -fr "$TRASH_DIRECTORY" || {
 623        GIT_EXIT_OK=t
 624        echo >&5 "FATAL: Cannot prepare test area"
 625        exit 1
 626}
 627
 628HOME="$TRASH_DIRECTORY"
 629export HOME
 630
 631if test -z "$TEST_NO_CREATE_REPO"
 632then
 633        test_create_repo "$TRASH_DIRECTORY"
 634else
 635        mkdir -p "$TRASH_DIRECTORY"
 636fi
 637# Use -P to resolve symlinks in our working directory so that the cwd
 638# in subprocesses like git equals our $PWD (for pathname comparisons).
 639cd -P "$TRASH_DIRECTORY" || exit 1
 640
 641this_test=${0##*/}
 642this_test=${this_test%%-*}
 643if match_pattern_list "$this_test" $GIT_SKIP_TESTS
 644then
 645        say_color info >&3 "skipping test $this_test altogether"
 646        skip_all="skip all tests in $this_test"
 647        test_done
 648fi
 649
 650# Provide an implementation of the 'yes' utility
 651yes () {
 652        if test $# = 0
 653        then
 654                y=y
 655        else
 656                y="$*"
 657        fi
 658
 659        while echo "$y"
 660        do
 661                :
 662        done
 663}
 664
 665# Fix some commands on Windows
 666case $(uname -s) in
 667*MINGW*)
 668        # Windows has its own (incompatible) sort and find
 669        sort () {
 670                /usr/bin/sort "$@"
 671        }
 672        find () {
 673                /usr/bin/find "$@"
 674        }
 675        sum () {
 676                md5sum "$@"
 677        }
 678        # git sees Windows-style pwd
 679        pwd () {
 680                builtin pwd -W
 681        }
 682        # no POSIX permissions
 683        # backslashes in pathspec are converted to '/'
 684        # exec does not inherit the PID
 685        test_set_prereq MINGW
 686        test_set_prereq NOT_CYGWIN
 687        test_set_prereq SED_STRIPS_CR
 688        ;;
 689*CYGWIN*)
 690        test_set_prereq POSIXPERM
 691        test_set_prereq EXECKEEPSPID
 692        test_set_prereq NOT_MINGW
 693        test_set_prereq CYGWIN
 694        test_set_prereq SED_STRIPS_CR
 695        ;;
 696*)
 697        test_set_prereq POSIXPERM
 698        test_set_prereq BSLASHPSPEC
 699        test_set_prereq EXECKEEPSPID
 700        test_set_prereq NOT_MINGW
 701        test_set_prereq NOT_CYGWIN
 702        ;;
 703esac
 704
 705( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
 706test -z "$NO_PERL" && test_set_prereq PERL
 707test -z "$NO_PYTHON" && test_set_prereq PYTHON
 708test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 709test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 710
 711# Can we rely on git's output in the C locale?
 712if test -n "$GETTEXT_POISON"
 713then
 714        GIT_GETTEXT_POISON=YesPlease
 715        export GIT_GETTEXT_POISON
 716        test_set_prereq GETTEXT_POISON
 717else
 718        test_set_prereq C_LOCALE_OUTPUT
 719fi
 720
 721# Use this instead of test_cmp to compare files that contain expected and
 722# actual output from git commands that can be translated.  When running
 723# under GETTEXT_POISON this pretends that the command produced expected
 724# results.
 725test_i18ncmp () {
 726        test -n "$GETTEXT_POISON" || test_cmp "$@"
 727}
 728
 729# Use this instead of "grep expected-string actual" to see if the
 730# output from a git command that can be translated either contains an
 731# expected string, or does not contain an unwanted one.  When running
 732# under GETTEXT_POISON this pretends that the command produced expected
 733# results.
 734test_i18ngrep () {
 735        if test -n "$GETTEXT_POISON"
 736        then
 737            : # pretend success
 738        elif test "x!" = "x$1"
 739        then
 740                shift
 741                ! grep "$@"
 742        else
 743                grep "$@"
 744        fi
 745}
 746
 747test_lazy_prereq PIPE '
 748        # test whether the filesystem supports FIFOs
 749        rm -f testfifo && mkfifo testfifo
 750'
 751
 752test_lazy_prereq SYMLINKS '
 753        # test whether the filesystem supports symbolic links
 754        ln -s x y && test -h y
 755'
 756
 757test_lazy_prereq CASE_INSENSITIVE_FS '
 758        echo good >CamelCase &&
 759        echo bad >camelcase &&
 760        test "$(cat CamelCase)" != good
 761'
 762
 763test_lazy_prereq UTF8_NFD_TO_NFC '
 764        # check whether FS converts nfd unicode to nfc
 765        auml=$(printf "\303\244")
 766        aumlcdiar=$(printf "\141\314\210")
 767        >"$auml" &&
 768        case "$(echo *)" in
 769        "$aumlcdiar")
 770                true ;;
 771        *)
 772                false ;;
 773        esac
 774'
 775
 776test_lazy_prereq AUTOIDENT '
 777        sane_unset GIT_AUTHOR_NAME &&
 778        sane_unset GIT_AUTHOR_EMAIL &&
 779        git var GIT_AUTHOR_IDENT
 780'
 781
 782# When the tests are run as root, permission tests will report that
 783# things are writable when they shouldn't be.
 784test -w / || test_set_prereq SANITY
 785
 786GIT_UNZIP=${GIT_UNZIP:-unzip}
 787test_lazy_prereq UNZIP '
 788        "$GIT_UNZIP" -v
 789        test $? -ne 127
 790'